## redisearch 1.0.8

=== Makefile ===
all:
	$(MAKE) -C ./src all

test:
	$(MAKE) -C ./src $@

clean:
	$(MAKE) -C ./src $@

distclean:
	$(MAKE) -C ./src $@
.PHONY: distclean

package: all
	$(MAKE) -C ./src package
.PHONY: package

buildall:
	$(MAKE) -C ./src $@

deploydocs:
	mkdocs gh-deploy
.PHONY: deploydocs

staticlib:
	$(MAKE) -C ./src $@

# Builds a small utility that outputs the current version
print_version:
	$(MAKE) -C ./src print_version

docker: distclean print_version
	docker build . -t redislabs/redisearch

docker_push: docker
	docker push redislabs/redisearch:latest
	docker tag redislabs/redisearch:latest redislabs/redisearch:`./src/print_version`
	docker push redislabs/redisearch:`./src/print_version`

=== src/Makefile ===

# find the OS
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

CC:=$(shell sh -c 'type $(CC) >/dev/null 2>/dev/null && echo $(CC) || echo gcc')
export CC

# if DEBUG env var is set, we compile with "debug" cflags
DEBUGFLAGS = -g -ggdb -O3 
ifeq ($(DEBUG), 1)
	DEBUGFLAGS = -g -ggdb -O0
endif

# Default CFLAGS
CFLAGS += -Wall -Wno-unused-function -Wno-unused-variable -Wno-unused-result -fPIC \
	-Werror=implicit-function-declaration \
 	-D_GNU_SOURCE -std=gnu99 -I"$(shell pwd)" -DREDIS_MODULE_TARGET \
	-DREDISMODULE_EXPERIMENTAL_API 
CFLAGS += $(DEBUGFLAGS)

LINKER=$(CC)
# Compile flags for non-osx / osx
ifneq ($(uname_S),Darwin)
	SHOBJ_LDFLAGS ?= -shared -Bsymbolic -Bsymbolic-functions -ldl -lpthread
else
	LINKER = $(LD)
	CFLAGS += -mmacosx-version-min=10.6
	SHOBJ_LDFLAGS ?= -macosx_version_min 10.6 -exported_symbol _RedisModule_OnLoad -bundle -undefined dynamic_lookup -ldl -lpthread
endif
export CFLAGS



# Sources
SOURCEDIR:=$(shell pwd -P)
CC_SOURCES := $(wildcard $(SOURCEDIR)/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/query_parser/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/ext/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/util/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/trie/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/dep/thpool/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/dep/cndict/*.c)

# Convert all sources to .o files
CC_OBJECTS = $(sort $(patsubst %.c, %.o, $(CC_SOURCES) ))

# .d files for each c file. These make sure that changing a header file
# will also change the dependent .c files of it
CC_DEPS = $(patsubst %.c, %.d, $(CC_SOURCES) )

MODULE_ARTIFACT=redisearch.so

# Library dependencies
LIBRMUTIL=rmutil/librmutil.a
LIBTRIE=trie/libtrie.a
LIBTRIEMAP=dep/triemap/libtriemap.a
LIBNU=dep/libnu/libnu.a
LIBSTEMMER=dep/snowball/libstemmer.o
LIBFRISO=dep/friso/libfriso.a
LIBMINIZ=dep/miniz/libminiz.a

# Compilation deps for the module
LIBS=$(LIBTRIE) $(LIBTRIEMAP) $(LIBRMUTIL) $(LIBNU) $(LIBFRISO) $(LIBSTEMMER)
# TODO: make conditional on chinese support
LIBS += $(LIBMINIZ)
MODULE=$(CC_OBJECTS) $(LIBS)

%.c: %.y

# Compile C file while generating a .d file for it
%.o: %.c
%.o: %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@ -MMD -MF $(@:.o=.d)

all: $(MODULE_ARTIFACT)


# Include all dependency files for C files
-include $(CC_DEPS)

# Library compile rules
$(LIBRMUTIL):
	$(MAKE) -C rmutil
.PHONY: $(LIBRMUTIL)
$(LIBTRIE):
	$(MAKE) -C trie
.PHONY: $(LIBTRIE)
$(LIBTRIEMAP):
	$(MAKE) -C dep/triemap
.PHONY: $(LIBTRIEMAP)
$(LIBSTEMMER):
	$(MAKE) -C dep/snowball libstemmer.o
.PHONY: $(LIBSTEMMER)
$(LIBNU):
	$(MAKE) -C dep/libnu
.PHONY: $(LIBNU)
$(LIBFRISO):
	$(MAKE) -C dep/friso -f Makefile.RediSearch
$(LIBMINIZ):
	$(MAKE) -C dep/miniz

# Compile query parse .y and .rl files. 
# This is not included in the usual make target!
query_parser:
	$(MAKE) -C $@
.PHONY: query_parser

build_cndict:
	$(MAKE) -C dep/cndict

build_tests: $(MODULE_ARTIFACT) libredisearch.a
	$(MAKE) -C tests build

test: $(MODULE) build_tests
	# low level redis-independant tests
	$(MAKE) -C ./tests test
	# high level python integration tests
	$(MAKE) -C pytest test
	# Triemap tests
	$(MAKE) -C dep/triemap/test test

buildall: $(MODULE_ARTIFACT) libredisearch.a build_tests

# Build the module...
$(MODULE_ARTIFACT): $(shell rm -f module.o)
$(MODULE_ARTIFACT): $(MODULE) version.h
	@# Just to make sure old versions of the modules are deleted
	rm -f module.so
	$(LINKER) -o $@ $(MODULE) $(SHOBJ_LDFLAGS) -lc -lm $(LDFLAGS)

# Build a stand-alone static library without the module entry point.
# This is used to include the module's functionality in other modules
libredisearch.a: CFLAGS+=-DRS_CMD_PREFIX='"_FT"' -DRS_STATIC
# remove module.o to make sure we are building it with the right defines
libredisearch.a: $(shell rm -f module.o)
libredisearch.a: $(CC_OBJECTS) $(LIBS) version.h
	
	ar rcs $@ $(CC_OBJECTS)

staticlib: libredisearch.a

clean:
	rm -fv *.[oad] trie/*.[oad] query_parser/*.[oad] ext/*.[oad]
	$(MAKE) -C tests clean

distclean: clean
	find . -type f \( -name '*.[oad]' -o -name '*.so' \) -delete -print

print_version: version.h print_version.c
	@$(CC) -o $@ -DPRINT_VERSION_TARGET $@.c

rebuild: clean all

=== src/query_parser/Makefile ===
%.c: %.y
parser:
	ragel -s lexer.rl -o lexer.c
	lemon -s -Ttemplate.c.tpl parser.y

.PHONY: parser
all: parser

=== src/dep/miniz/Makefile ===
all: libminiz.a

libminiz.a: miniz.o
	$(AR) rcs $@ $^

=== src/dep/triemap/test/Makefile ===
# find the OS
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

# Compile flags for linux / osx
CFLAGS ?= -fno-common -g -ggdb -fPIC -std=gnu99 -O3 
LDFLAGS ?= -lm
SOURCEDIR = .
CC_SOURCES = $(SOURCEDIR)/crc16.c
CC_OBJECTS = $(sort $(patsubst $(SOURCEDIR)/%.c, $(SOURCEDIR)/%.o, $(CC_SOURCES)))

.SUFFIXES: .c .cc .o

all: test test_valgrind

benchmark: $(CC_SOURCES) benchmark.c ../triemap.c
	$(CC) $(CFLAGS) -o benchmark $^  $(LDFLAGS)
.PHONY = benchmark

build_test: $(CC_SOURCES) test.c ../triemap.c
	$(CC) $(CFLAGS) -o test $^  $(LDFLAGS)

.PHONY: test
test: build_test
	$(sh) ./test

test_valgrind: build_test

	valgrind --error-exitcode=1 --leak-resolution=low --quiet \
            --leak-check=full --show-possibly-lost=no ./test



clean:
	rm -rf *.o *.a benchmark test

=== debian/changelog ===
redisearch (1.0.8-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Wed, 28 Feb 2018 13:59:26 +0000

redisearch (1.0.7-1) unstable; urgency=medium

  * New upstream realease.
  * Move debhelper Build-Depends from 11 to 11~.
  * Override package-does-not-install-examples; these are for a dependency.

 -- Chris Lamb <lamby@debian.org>  Mon, 12 Feb 2018 10:10:43 +0000

redisearch (1.0.6-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 02 Feb 2018 09:29:42 +0000

redisearch (1.0.5-1) unstable; urgency=medium

  * New upstream release.
  * Use HTTPS URI for debian/copyright "Format" URI.

 -- Chris Lamb <lamby@debian.org>  Wed, 24 Jan 2018 22:30:20 +1100

redisearch (1.0.4-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 12 Jan 2018 10:26:07 +0530

redisearch (1.0.3-1) unstable; urgency=medium

  * New upstream release.
  * Remove 0001-Use-build-flags-from-outside-environment.patch; applied
    upstream.
  * Bump debhelper compat level to 11.
  * Bump Standards-Version to 4.1.3.
  * Don't install README.md into both binary packages.

 -- Chris Lamb <lamby@debian.org>  Sat, 06 Jan 2018 11:11:34 +0000

redisearch (1.0.2-1) unstable; urgency=medium

  * New upstream release.
  * Update 0001-Use-build-flags-from-outside-environment.patch to ensure .so
    file is hardened. Filed upstream:
    <https://github.com/RedisLabsModules/RediSearch/pull/245>
  * Update upstream's .gitignore so our changes to debian/ are visible without
    -f. Filed upstream as
    <https://github.com/RedisLabsModules/RediSearch/pull/244>.
  * Override no-upstream-changelog in all binary packages.

 -- Chris Lamb <lamby@debian.org>  Fri, 15 Dec 2017 17:49:39 +0000

redisearch (1.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.2.

 -- Chris Lamb <lamby@debian.org>  Sun, 10 Dec 2017 20:52:30 +0000

redisearch (1.0.0-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Wed, 29 Nov 2017 08:07:16 +0900

redisearch (0.99.2-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Mon, 27 Nov 2017 20:18:03 +0900

redisearch (0.99.0-1) unstable; urgency=medium

  * New upstream release.
  * Add override as upstream are not providing GPG signatures.
  * debian/watch:
    - Move to version 4 format.
    - Strip leading v from upstream URL.

 -- Chris Lamb <lamby@debian.org>  Sat, 18 Nov 2017 16:56:45 +0900

redisearch (0.90.1-1) unstable; urgency=medium

  * New upstream release.
    - Fix FTBFS on 32-bits architectures. (Closes: #880801)

 -- Chris Lamb <lamby@debian.org>  Sun, 05 Nov 2017 15:37:39 +0000

redisearch (0.90.0~alpha1-1) unstable; urgency=medium

  * New upstream alpha release.
  * debian/patches:
    - Refresh 0001-Use-build-flags-from-outside-environment.patch.
    - Drop 0002-Don-t-assume-that-non-Linux-is-OSX.-Closes-879948.patch;
      applied upstream.
  * debian/watch: Match all releases.

 -- Chris Lamb <lamby@debian.org>  Thu, 02 Nov 2017 19:51:29 +0100

redisearch (0.21.3-5) unstable; urgency=medium

  * Don't assume that non-Linux is OSX. (Closes: #879948)

 -- Chris Lamb <lamby@debian.org>  Fri, 27 Oct 2017 16:09:14 +0100

redisearch (0.21.3-4) unstable; urgency=medium

  * Install to /usr/lib/redis/modules/redisearch.so, not
    /var/lib/redis/modules/redisearch.so.

 -- Chris Lamb <lamby@debian.org>  Thu, 26 Oct 2017 12:53:15 +0100

redisearch (0.21.3-3) unstable; urgency=medium

  * Update debian/copyright.

 -- Chris Lamb <lamby@debian.org>  Wed, 25 Oct 2017 10:05:45 -0400

redisearch (0.21.3-2) unstable; urgency=medium

  * Specify Section: doc for redis-redisearch-doc.
  * Enable bindnow hardening.
  * Use build flags from outside environment.

 -- Chris Lamb <lamby@debian.org>  Tue, 24 Oct 2017 19:08:34 -0400

redisearch (0.21.3-1) unstable; urgency=medium

  * Initial release. (Closes: #879203)

 -- Chris Lamb <lamby@debian.org>  Tue, 24 Oct 2017 18:29:18 -0400

=== debian/control ===
Source: redisearch
Section: python
Priority: optional
Maintainer: Chris Lamb <lamby@debian.org>
Build-Depends:
 debhelper (>= 11~),
Standards-Version: 4.1.3
Homepage: http://redisearch.io
Vcs-Git: https://github.com/lamby/pkg-redisearch.git
Vcs-Browser: https://github.com/lamby/pkg-redisearch

Package: redis-redisearch
Architecture: any
Depends:
 redis-server,
 ${misc:Depends},
 ${shlibs:Depends},
Description: Full-text and secondary search index engine module for Redis
 Redisearch implements a search engine on top of Redis but unlike other search
 libraries it does not use internal data structures such as sorted sets.
 .
 This also enables more advanced features such as exact phrase matching and
 numeric filtering for text queries that are not possible or efficient with
 traditional Redis search approaches.

Package: redis-redisearch-doc
Section: doc
Architecture: all
Depends:
 ${misc:Depends},
Description: Full-text and secondary search index engine module for Redis (documentation)
 Redisearch implements a search engine on top of Redis but unlike other search
 libraries it does not use internal data structures such as sorted sets.
 .
 This also enables more advanced features such as exact phrase matching and
 numeric filtering for text queries that are not possible or efficient with
 traditional Redis search approaches.
 .
 This package contains the documentation for redisearch.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

DPKG_EXPORT_BUILDFLAGS = 1

include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_test:
	# Tests require Python "rmtest" which is not in Debian.

override_dh_installdocs:
	dh_installdocs
	rm -f ./debian/redis-redisearch-doc/usr/share/doc/redis-redisearch-doc/docs/CNAME

override_dh_compress:
	dh_compress -X.md

=== debian/tests/control ===
Tests: load-module
Depends: @, redis-server

=== debian/watch ===
version=4
opts="uversionmangle=s/^v//g" \
https://github.com/RedisLabsModules/RediSearch/releases .*/archive/(.*).tar.gz

## redisearch 1.0.9

=== src/tests/Makefile ===
ifndef RM_INCLUDE_DIR
	RM_INCLUDE_DIR=../
endif

CFLAGS = -g -O3 -fPIC -D_GNU_SOURCE -std=gnu99 -I./  -Werror=implicit-function-declaration
CFLAGS += -I$(RM_INCLUDE_DIR)
%.c: %.y

ifndef VERBOSE
.SILENT:
endif

# Sources
SOURCEDIR=$(abspath $(shell pwd -P)/../)
CC_SOURCES = $(wildcard $(SOURCEDIR)/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/query_parser/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/ext/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/util/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/trie/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/dep/thpool/*.c) 
CC_SOURCES += $(wildcard $(SOURCEDIR)/dep/cndict/*.c)

# Convert all sources to .o files
DEP_OBJECTS = $(patsubst %.c, %.o, $(CC_SOURCES) )
CC_DEPS = $(patsubst %.c, %.d, $(CC_SOURCES) )


TEST_SOURCES = $(abspath $(wildcard test_*.c))
TEST_OBJECTS = $(patsubst %.c, %.o, $(TEST_SOURCES)  )
TEST_EXECUTABLES = $(patsubst %.c, %.run, $(TEST_SOURCES)  )
TEST_DEPS = $(patsubst %.c, %.d,$(TEST_SOURCES))

# Library dependencies
DEP_LIBS = ../rmutil/librmutil.a ../trie/libtrie.a ../dep/triemap/libtriemap.a \
		   ../dep/libnu/libnu.a ../dep/snowball/libstemmer.o ../dep/friso/libfriso.a \
		   ../dep/miniz/libminiz.a
DEPS = $(DEP_OBJECTS) $(DEP_LIBS)
SRCDIR := $(shell pwd)
LDFLAGS :=  -lc -lm -ldl -lpthread

CC=gcc

%.o: %.c
%.o: %.c
	$(CC) $(CFLAGS) $(CPPFLAGS) $(TARGET_ARCH) -c $< -o $@ -MMD -MF $(@:.o=.d)


all: build test

# Including this stuff makes sure everything gets built on changes to the source directory
-include $(TEST_DEPS)
-include $(CC_DEPS)

# The exampe extension is a dependency to extension tests
ext_example:
	$(MAKE) -C ./ext-example clean all
.PHONY: ext_example

# Compiling each test runner from its .o file
%.run: %.o
	$(CC) $(CFLAGS) -o $@ $^  $(DEPS) $(LDFLAGS)
# extra rule for test_extensions.run
test_extensions.run: | ext_example


build: $(TEST_OBJECTS) $(TEST_EXECUTABLES) $(DEPS) ext_example

# Test all
test: build $(TEST_EXECUTABLES)
	set -e; \
	for t in test_*.run;\
	 do ./$$t;\
	done

memcheck: build $(TEST_EXECUTABLES)
	set -e; \
	for t in test_*.run;\
	 do valgrind --tool=memcheck --leak-check=full --error-exitcode=1 --show-possibly-lost=no ./$$t;\
	done

# Target for individual tests - make run:{test name}, e.g. "make run:query" will run test_query.run
run\:%: 
	$(MAKE) test_$*.run
	./test_$*.run

clean:
	-rm -f *.o
	-rm -f *.run
	-rm -f ext-example/*.o ext-example/*.so 

.PHONY: clean

rebuild: clean all

=== src/trie/Makefile ===
# set environment variable RM_INCLUDE_DIR to the location of redismodule.h
ifndef RM_INCLUDE_DIR
	RM_INCLUDE_DIR=../
endif

CFLAGS ?= -g -fPIC -O3 -std=gnu99 -Wall -Wno-unused-function -Wno-unused-variable
CFLAGS += -I$(RM_INCLUDE_DIR)
CC=gcc
OBJS=levenshtein.o rune_util.o sparse_vector.o trie.o trie_type.o

all: libtrie.a

clean:
	rm -rf *.o *.a

libtrie.a: $(OBJS)
	ar rcs $@ $^

# test_trie: test.o $(OBJS)
# 	$(CC) -Wall -o test test.o $(OBJS) -lc -O0
# 	@(sh -c ./test_vector)

=== src/dep/libnu/Makefile ===
# find the OS
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')

# Compile flags for non-osx / osx
ifneq ($(uname_S),Darwin)
	CFLAGS ?= -W -Wall -fno-common -g -ggdb -fPIC -std=c99 -O2
	CPPFLAGS ?= -W -Wall -fno-common -g -ggdb
else
	CFLAGS ?= -W -Wall -dynamic -fno-common -g -fPIC -ggdb -std=c99 -O2
	CPPFLAGS ?= -W -Wall -dynamic -fno-common -g -ggdb -O2
endif

SOURCEDIR = .
CC_SOURCES = $(wildcard $(SOURCEDIR)/*.c)
CC_OBJECTS = $(sort $(patsubst $(SOURCEDIR)/%.c, $(SOURCEDIR)/%.o, $(CC_SOURCES)))

.SUFFIXES: .c .cc .o

all: libnu.a

# $(SOURCEDIR)/%.o: $(SOURCEDIR)/%.c
# 	$(CC) -I. $(SHOBJ_CFLAGS) -fPIC -fpermissive -c $< -o $@

# test1.xo: ../redismodule.h

libnu.a: $(CC_OBJECTS)
	ar rcs $@ $^

clean:
	rm -rf *.xo *.so *.o *.a

=== debian/changelog ===
redisearch (1.0.9-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Fri, 23 Mar 2018 18:20:23 -0400

## redisearch 1.2.1

=== CMakeLists.txt ===
CMAKE_MINIMUM_REQUIRED(VERSION 2.8.9)
PROJECT(redisearch)

OPTION(RS_RUN_TESTS "Build & Run RediSearch's tests" ON)

SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=gnu99")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall -Wno-unused-function -Wno-unused-variable -Wno-unused-result")
SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fPIC -Werror=implicit-function-declaration -pthread")

STRING(REPLACE "-DNDEBUG" "" CMAKE_C_FLAGS_RELEASE "${CMAKE_C_FLAGS_RELEASE}")
STRING(REPLACE "-DNDEBUG" "" CMAKE_C_FLAGS_RELWITHDEBINFO "${CMAKE_C_FLAGS_RELWITHDEBINFO}")
STRING(REPLACE "-DNDEBUG" "" CMAKE_C_FLAGS "${CMAKE_C_FLAGS}")


EXECUTE_PROCESS(COMMAND git describe
    WORKING_DIRECTORY "${CURRENT_SOURCE_DIR}"
    OUTPUT_VARIABLE GIT_DESCRIBE_VERSION
    OUTPUT_STRIP_TRAILING_WHITESPACE)

MESSAGE("${GIT_DESCRIBE_VERSION}")

IF (GIT_DESCRIBE_VERSION)
    ADD_DEFINITIONS(-DRS_GIT_VERSION="${GIT_DESCRIBE_VERSION}")
ENDIF (GIT_DESCRIBE_VERSION)


# Set globals here!
INCLUDE_DIRECTORIES(${PROJECT_SOURCE_DIR}/src)
ADD_DEFINITIONS(-DREDISMODULE_EXPERIMENTAL_API)
ADD_DEFINITIONS(-D_GNU_SOURCE)
ADD_DEFINITIONS(-DREDIS_MODULE_TARGET)

ADD_SUBDIRECTORY(src/rmutil)
ADD_SUBDIRECTORY(src/dep/friso)
ADD_SUBDIRECTORY(src/dep/snowball)

FILE(GLOB RS_SRC
    "src/*.c"
    "src/aggregate/*.c"
    "src/aggregate/expr/*.c"
    "src/aggregate/functions/*.c"
    "src/aggregate/reducers/*.c"
    "src/ext/*.c"
    "src/query_parser/*.c"
    "src/util/*.c"
    "src/trie/*.c"
    "src/dep/cndict/cndict_data.c"
    "src/dep/hll/*.c"
    "src/dep/libnu/*.c"
    "src/dep/miniz/*.c"
    "src/dep/thpool/*.c"
    "src/dep/triemap/*.c")


ADD_LIBRARY(rscore OBJECT ${RS_SRC})

SET(FINAL_OBJECTS
    $<TARGET_OBJECTS:rscore>
    $<TARGET_OBJECTS:rmutil>
    $<TARGET_OBJECTS:friso>
    $<TARGET_OBJECTS:snowball>)

ADD_LIBRARY(redisearchS STATIC ${FINAL_OBJECTS})
ADD_LIBRARY(redisearch SHARED ${FINAL_OBJECTS} src/module-init/module-init.c)

SET_TARGET_PROPERTIES(redisearch PROPERTIES PREFIX "")
SET_TARGET_PROPERTIES(redisearch PROPERTIES SUFFIX ".so")
TARGET_LINK_LIBRARIES(redisearchS -lm -lc -ldl)

IF (RS_RUN_TESTS)
    ENABLE_TESTING()
    ADD_SUBDIRECTORY(src/tests)
    ADD_SUBDIRECTORY(src/pytest)
ENDIF()

=== requirements.txt ===
redis
rmtest

=== src/Makefile ===
--- 
+++ 
@@ -18,10 +18,16 @@
 	-DREDISMODULE_EXPERIMENTAL_API 
 CFLAGS += $(DEBUGFLAGS)
 
+GITVERSION=$(shell git describe)
+ifdef GITVERSION
+	CFLAGS += -DRS_GIT_VERSION=\"$(GITVERSION)\"
+endif
+
 LINKER=$(CC)
 # Compile flags for non-osx / osx
 ifneq ($(uname_S),Darwin)
 	SHOBJ_LDFLAGS ?= -shared -Bsymbolic -Bsymbolic-functions -ldl -lpthread
+	CFLAGS += -Wfree-nonheap-object
 else
 	LINKER = $(LD)
 	CFLAGS += -mmacosx-version-min=10.6
@@ -38,8 +44,12 @@
 CC_SOURCES += $(wildcard $(SOURCEDIR)/ext/*.c) 
 CC_SOURCES += $(wildcard $(SOURCEDIR)/util/*.c) 
 CC_SOURCES += $(wildcard $(SOURCEDIR)/trie/*.c) 
+CC_SOURCES += $(wildcard $(SOURCEDIR)/aggregate/*.c) 
+CC_SOURCES += $(wildcard $(SOURCEDIR)/aggregate/*/*.c) 
 CC_SOURCES += $(wildcard $(SOURCEDIR)/dep/thpool/*.c) 
+CC_SOURCES += $(wildcard $(SOURCEDIR)/dep/hll/*.c) 
 CC_SOURCES += $(wildcard $(SOURCEDIR)/dep/cndict/*.c)
+CC_SOURCES += $(wildcard $(SOURCEDIR)/module-init/*.c)
 
 # Convert all sources to .o files
 CC_OBJECTS = $(sort $(patsubst %.c, %.o, $(CC_SOURCES) ))
@@ -58,9 +68,11 @@
 LIBSTEMMER=dep/snowball/libstemmer.o
 LIBFRISO=dep/friso/libfriso.a
 LIBMINIZ=dep/miniz/libminiz.a
+LIBBLOOM=dep/bloom/libbloom.a
 
 # Compilation deps for the module
-LIBS=$(LIBTRIE) $(LIBTRIEMAP) $(LIBRMUTIL) $(LIBNU) $(LIBFRISO) $(LIBSTEMMER)
+LIBS=$(LIBTRIE) $(LIBTRIEMAP) $(LIBRMUTIL) $(LIBNU) $(LIBFRISO) $(LIBSTEMMER) \
+	 $(LIBBLOOM)
 # TODO: make conditional on chinese support
 LIBS += $(LIBMINIZ)
 MODULE=$(CC_OBJECTS) $(LIBS)
@@ -98,6 +110,8 @@
 	$(MAKE) -C dep/friso -f Makefile.RediSearch
 $(LIBMINIZ):
 	$(MAKE) -C dep/miniz
+$(LIBBLOOM):
+	$(MAKE) -C dep/bloom
 
 # Compile query parse .y and .rl files. 
 # This is not included in the usual make target!

=== src/pytest/CMakeLists.txt ===
# Find all the Python files with test_* in them
FILE(GLOB PY_TEST_FILES "test_*.py")

FOREACH(n ${PY_TEST_FILES})
    GET_FILENAME_COMPONENT(test_name ${n} NAME_WE)
    ADD_TEST(NAME "PY_${test_name}"
        COMMAND "python" "-m" "unittest" "${test_name}"
        WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
    SET_TESTS_PROPERTIES("PY_${test_name}" PROPERTIES ENVIRONMENT
        "REDIS_MODULE_PATH=$<TARGET_FILE:redisearch>")
ENDFOREACH()

=== src/pytest/Makefile ===
test:
	python -m unittest discover -v

=== src/query_parser/Makefile ===
SRCUTIL := ../../srcutil
PARSER_SYMBOL_PREFIX := RSQuery
include $(SRCUTIL)/make-parser.mk

=== src/rmutil/CMakeLists.txt ===
ADD_LIBRARY(rmutil OBJECT
    alloc.c
    cmdparse.c
    heap.c
    periodic.c
    priority_queue.c
    sds.c
    strings.c
    util.c
    vector.c)

=== src/rmutil/Makefile ===
# set environment variable RM_INCLUDE_DIR to the location of redismodule.h
ifndef RM_INCLUDE_DIR
	RM_INCLUDE_DIR=../
endif

CFLAGS ?= -g -fPIC -O3 -std=gnu99 -Wall -Wno-unused-function
CFLAGS += -I$(RM_INCLUDE_DIR)
CC=gcc

OBJS=util.o strings.o sds.o vector.o alloc.o periodic.o cmdparse.o

all: librmutil.a

clean:
	rm -rf *.o *.a

librmutil.a: $(OBJS)
	ar rcs $@ $^

test_vector: test_vector.o vector.o
	$(CC) -Wall -o $@ $^ -lc -lpthread -O0
	@(sh -c ./$@)
.PHONY: test_vector

test_periodic: test_periodic.o periodic.o
	$(CC) -Wall -o $@ $^ -lc -lpthread -O0
	@(sh -c ./$@)
.PHONY: test_periodic

test_cmdparse: test_cmdparse.o cmdparse.o
	$(CC) -Wall -o $@ $^ -lc -lpthread -O0
	@(sh -c ./$@)

.PHONY: test_cmdparse
test: test_periodic test_vector
.PHONY: test

=== src/tests/CMakeLists.txt ===
INCLUDE (CTest)

FUNCTION(RSTEST name)
    ADD_EXECUTABLE("${name}" "${name}.c")
    TARGET_LINK_LIBRARIES("${name}" "redisearchS")
    ADD_TEST(NAME "${name}" COMMAND "${name}" WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}")
ENDFUNCTION()

FILE(GLOB TEST_SOURCES "test_*.c")

FOREACH(n ${TEST_SOURCES})
    GET_FILENAME_COMPONENT(test_name ${n} NAME_WE)
    MESSAGE("${n} => ${test_name}")
    RSTEST("${test_name}")
ENDFOREACH()

ADD_LIBRARY(example_extension SHARED "ext-example/example.c")
ADD_DEPENDENCIES(test_extensions example_extension)
SET_TESTS_PROPERTIES(test_extensions PROPERTIES ENVIRONMENT "EXT_TEST_PATH=$<TARGET_FILE:example_extension>")

=== src/tests/Makefile ===
--- 
+++ 
@@ -2,7 +2,7 @@
 	RM_INCLUDE_DIR=../
 endif
 
-CFLAGS = -g -O3 -fPIC -D_GNU_SOURCE -std=gnu99 -I./  -Werror=implicit-function-declaration
+CFLAGS = -g -ggdb -O0 -fPIC -D_GNU_SOURCE -std=gnu99 -I./  -Werror=implicit-function-declaration
 CFLAGS += -I$(RM_INCLUDE_DIR)
 %.c: %.y
 
@@ -15,14 +15,17 @@
 CC_SOURCES = $(wildcard $(SOURCEDIR)/*.c) 
 CC_SOURCES += $(wildcard $(SOURCEDIR)/query_parser/*.c) 
 CC_SOURCES += $(wildcard $(SOURCEDIR)/ext/*.c) 
+CC_SOURCES += $(wildcard $(SOURCEDIR)/aggregate/*.c) 
+CC_SOURCES += $(wildcard $(SOURCEDIR)/aggregate/*/*.c)
 CC_SOURCES += $(wildcard $(SOURCEDIR)/util/*.c) 
 CC_SOURCES += $(wildcard $(SOURCEDIR)/trie/*.c) 
 CC_SOURCES += $(wildcard $(SOURCEDIR)/dep/thpool/*.c) 
+CC_SOURCES += $(wildcard $(SOURCEDIR)/dep/hll/*.c) 
 CC_SOURCES += $(wildcard $(SOURCEDIR)/dep/cndict/*.c)
 
 # Convert all sources to .o files
-DEP_OBJECTS = $(patsubst %.c, %.o, $(CC_SOURCES) )
-CC_DEPS = $(patsubst %.c, %.d, $(CC_SOURCES) )
+DEP_OBJECTS := $(patsubst %.c, %.o, $(CC_SOURCES) )
+CC_DEPS := $(patsubst %.c, %.d, $(CC_SOURCES) )
 
 
 TEST_SOURCES = $(abspath $(wildcard test_*.c))
@@ -33,7 +36,7 @@
 # Library dependencies
 DEP_LIBS = ../rmutil/librmutil.a ../trie/libtrie.a ../dep/triemap/libtriemap.a \
 		   ../dep/libnu/libnu.a ../dep/snowball/libstemmer.o ../dep/friso/libfriso.a \
-		   ../dep/miniz/libminiz.a
+		   ../dep/miniz/libminiz.a ../dep/bloom/libbloom.a
 DEPS = $(DEP_OBJECTS) $(DEP_LIBS)
 SRCDIR := $(shell pwd)
 LDFLAGS :=  -lc -lm -ldl -lpthread

=== src/aggregate/expr/Makefile ===
SRCUTIL = ../../../srcutil
PARSER_SYMBOL_PREFIX=RSExprParser

include $(SRCUTIL)/make-parser.mk

=== src/dep/friso/CMakeLists.txt ===
IF ("${CMAKE_C_COMPILER_ID}" MATCHES "Clang")
    SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wno-tautological-compare")
ENDIF()

ADD_LIBRARY(friso OBJECT
    friso.c
    friso_array.c
    friso_hash.c
    friso_lexicon.c
    friso_link.c
    friso_string.c
    friso_ctype.c
    friso_UTF8.c
    friso_GBK.c)

=== debian/changelog ===
redisearch (1:1.2.1-4) unstable; urgency=medium

  * Pass -ffile-prefix-map for a reproducible build.

 -- Chris Lamb <lamby@debian.org>  Tue, 22 Jan 2019 10:22:39 +0000

redisearch (1:1.2.1-3) unstable; urgency=medium

  * Check for __FreeBSD_kernel__ over __FreeBSD__ for CLOCK_MONOTONIC_RAW.
    Thanks to James Clarke for the pointer.

 -- Chris Lamb <lamby@debian.org>  Mon, 14 Jan 2019 00:05:08 +0000

redisearch (1:1.2.1-2) unstable; urgency=medium

  * Define CLOCK_MONOTONIC_RAW for kFreeBSD.
  * debian/control:
    - Bump debhelper compatibility level.
    - Bump Standards-Version to 4.3.0.

 -- Chris Lamb <lamby@debian.org>  Wed, 02 Jan 2019 17:18:52 +0000

redisearch (1:1.2.1-1) unstable; urgency=medium

  * Package the last AGPLv3 (ie. non Commons Clause) package from the GoodFORM
    project <https://goodformcode.com/>, regrettably bumping the epoch.
    - Update debian/copyright.
    - Update debian/watch.
    - Update Homepage field.
  * Use debhelper-compat virtual package and drop debian/compat.
  * Bump Standards-Version to 4.2.1.

 -- Chris Lamb <lamby@debian.org>  Wed, 24 Oct 2018 20:48:33 -0400

redisearch (1.4.0~rc3-1) unstable; urgency=medium

  * New upstream RC release.
  * debian/watch: Also mangle "rc" releases.

 -- Chris Lamb <lamby@debian.org>  Sun, 19 Aug 2018 09:48:57 +0100

redisearch (1.4.0~rc1-1) unstable; urgency=medium

  * New upstream RC release.

 -- Chris Lamb <lamby@debian.org>  Thu, 16 Aug 2018 09:53:59 +0100

redisearch (1.3.0~preview3-1) unstable; urgency=medium

  * New upstream preview release.
  * Bump Standards-Version to 4.2.0.

 -- Chris Lamb <lamby@debian.org>  Sat, 11 Aug 2018 18:22:01 +0200

redisearch (1.3.0~preview2-1) unstable; urgency=medium

  * New upstream preview release.
    - Add cmake to Build-Depends.
  * debian/watch: Support beta/preview suffixes.
  * Bump Standards-Version to 4.1.5.

 -- Chris Lamb <lamby@debian.org>  Thu, 02 Aug 2018 10:12:40 +0800

redisearch (1.2.0-2) unstable; urgency=medium

  * Update Vcs-* to point to salsa.debian.org.

 -- Chris Lamb <lamby@debian.org>  Fri, 08 Jun 2018 17:47:16 +0100

redisearch (1.2.0-1) unstable; urgency=medium

  * New upstream release.

 -- Chris Lamb <lamby@debian.org>  Tue, 15 May 2018 08:42:32 +0100

redisearch (1.1.0-1) unstable; urgency=medium

  * New upstream release.
    - Drop debian/patches/0001-remove-mpopcnt-and-opt-for-simple-pop-counting;
      applied upstream.

 -- Chris Lamb <lamby@debian.org>  Wed, 25 Apr 2018 07:53:20 +0100

redisearch (1.0.10-3) unstable; urgency=medium

  * Use upstream's patch for removing -mpopcnt.

 -- Chris Lamb <lamby@debian.org>  Tue, 24 Apr 2018 22:35:11 +0100

redisearch (1.0.10-2) unstable; urgency=medium

  * Drop -mpopcnt from CLAGS. This was added upstream in
    <https://github.com/RedisLabsModules/RediSearch/commit/a693e0e1c92e629bfdc78afcd00b1050e68dd238>.
    (Closes: #896593)

 -- Chris Lamb <lamby@debian.org>  Sun, 22 Apr 2018 22:16:23 +0200

redisearch (1.0.10-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.1.4.

 -- Chris Lamb <lamby@debian.org>  Sat, 21 Apr 2018 21:52:16 +0200

=== debian/control ===
--- 
+++ 
@@ -3,11 +3,12 @@
 Priority: optional
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
- debhelper (>= 11~),
-Standards-Version: 4.1.3
-Homepage: http://redisearch.io
-Vcs-Git: https://github.com/lamby/pkg-redisearch.git
-Vcs-Browser: https://github.com/lamby/pkg-redisearch
+ cmake,
+ debhelper-compat (= 12),
+Standards-Version: 4.3.0
+Homepage: https://github.com/goodform/RediSearch
+Vcs-Git: https://salsa.debian.org/lamby/pkg-redisearch.git
+Vcs-Browser: https://salsa.debian.org/lamby/pkg-redisearch
 
 Package: redis-redisearch
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #!/usr/bin/make -f
 
-export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+fixfilepath
 
 DPKG_EXPORT_BUILDFLAGS = 1

## redisearch 1.2.2

=== Makefile ===
--- 
+++ 
@@ -30,9 +30,9 @@
 	$(MAKE) -C ./src print_version
 
 docker: distclean print_version
-	docker build . -t redislabs/redisearch
+	docker build . -t goodform/redisearch
 
 docker_push: docker
-	docker push redislabs/redisearch:latest
-	docker tag redislabs/redisearch:latest redislabs/redisearch:`./src/print_version`
-	docker push redislabs/redisearch:`./src/print_version`
+	docker push goodform/redisearch:latest
+	docker tag goodform/redisearch:latest goodform/redisearch:`./src/print_version`
+	docker push goodform/redisearch:`./src/print_version`

=== src/benchmark/Makefile ===
CFLAGS = -g -O3 -std=gnu99 -I/usr/local/include -Wall -Wno-unused-function
LDFLAGS= -L/usr/local/lib -lhiredis -lev -lc -lm -static
CC=gcc

benchmark: benchmark.o
	$(CC) -o ./benchmark benchmark.o $(LDFLAGS)

all: benchmark

=== src/ext/Makefile ===
CFLAGS ?= -g -fPIC -lc -lm -O2 -std=gnu99

.SUFFIXES: .c .so .xo .o

all: default.o

=== src/pytest/Makefile ===
PYTHON:=python2

test:
	$(PYTHON) -m unittest discover -v

=== src/util/Makefile ===
CFLAGS ?= -g -ggdb -fPIC -lc -lm -O2 -std=gnu99

CC=gcc
.SUFFIXES: .c .so .xo .o

all: heap.o logging.o fnv.o block_alloc.o

=== src/dep/bloom/Makefile ===
all: libbloom.a

libbloom.a: sb.o contrib/MurmurHash2.o
	$(AR) -rcs $@ $^

=== src/dep/cndict/Makefile ===
FRISO_INI 		:= friso.ini
FRISO_LEXDIR	:= lex
PYTHON			:= python

cndict_data.c: bundle_friso.py
	$(PYTHON) bundle_friso.py -i $(FRISO_INI) -d $(FRISO_LEXDIR) -o .

clean:
	rm -rf cndict_data.c

=== src/tests/ext-example/Makefile ===
#set environment variable RS_INCLUDE_DIR to the location of redismodule.h
ifndef RS_INCLUDE_DIR
	RS_INCLUDE_DIR=../../
endif

# find the OS
uname_S := $(shell sh -c 'uname -s 2>/dev/null || echo not')
CFLAGS = -I$(RS_INCLUDE_DIR) -Wall -g -fPIC -O0 -std=gnu99  
CC:=$(shell sh -c 'type $(CC) >/dev/null 2>/dev/null && echo $(CC) || echo gcc')

# Compile flags for non-osx / osx
ifneq ($(uname_S),Darwin)
	SHOBJ_CFLAGS ?=  -fno-common -g -ggdb
	SHOBJ_LDFLAGS ?= -shared -Bsymbolic
else
	CFLAGS += -mmacosx-version-min=10.6
	SHOBJ_CFLAGS ?= -dynamic -fno-common -g -ggdb
	SHOBJ_LDFLAGS ?= -dylib -exported_symbol _RS_ExtensionInit -macosx_version_min 10.6
endif

all: example.so

example.so: example.o
	$(LD) -o $@ example.o $(SHOBJ_LDFLAGS) $(LIBS) -lc 

clean:
	rm -rf *.xo *.so *.o

FORCE:

=== debian/changelog ===
redisearch (1:1.2.2-4) unstable; urgency=medium

  [ Chris Lamb ]
  * Redis modules require executable permissions, otherwise redis-server will
    refuse to start. (Closes: #989385)
  * Drop some binary overrides.
  * Bump debhelper compatibility level to 13.
  * Apply wrap-and-sort -sa.

  [ Debian Janitor ]
  * Apply multi-arch hints. + redis-redisearch-doc: Add Multi-Arch: foreign.

 -- Chris Lamb <lamby@debian.org>  Wed, 02 Jun 2021 16:28:14 +0100

redisearch (1:1.2.2-3) unstable; urgency=medium

  * Sleep to ensure the server has started before running the autopkgtests.

 -- Chris Lamb <lamby@debian.org>  Thu, 23 Apr 2020 13:31:42 +0100

redisearch (1:1.2.2-2) unstable; urgency=medium

  * Ensure that the server is started before running autopkgtests.

 -- Chris Lamb <lamby@debian.org>  Mon, 20 Apr 2020 23:46:17 +0100

redisearch (1:1.2.2-1) unstable; urgency=medium

  * New upstream release.
  * Bump Standards-Version to 4.5.0.
  * Add Rules-Requires-Root: no.

 -- Chris Lamb <lamby@debian.org>  Wed, 15 Apr 2020 11:34:54 +0100

=== debian/control ===
--- 
+++ 
@@ -4,11 +4,12 @@
 Maintainer: Chris Lamb <lamby@debian.org>
 Build-Depends:
  cmake,
- debhelper-compat (= 12),
-Standards-Version: 4.3.0
+ debhelper-compat (= 13),
+Standards-Version: 4.5.0
 Homepage: https://github.com/goodform/RediSearch
 Vcs-Git: https://salsa.debian.org/lamby/pkg-redisearch.git
 Vcs-Browser: https://salsa.debian.org/lamby/pkg-redisearch
+Rules-Requires-Root: no
 
 Package: redis-redisearch
 Architecture: any
@@ -29,6 +30,7 @@
 Architecture: all
 Depends:
  ${misc:Depends},
+Multi-Arch: foreign
 Description: Full-text and secondary search index engine module for Redis (documentation)
  Redisearch implements a search engine on top of Redis but unlike other search
  libraries it does not use internal data structures such as sorted sets.

=== debian/rules ===
--- 
+++ 
@@ -16,5 +16,12 @@
 	dh_installdocs
 	rm -f ./debian/redis-redisearch-doc/usr/share/doc/redis-redisearch-doc/docs/CNAME
 
+override_dh_fixperms:
+	dh_fixperms
+	
+	# Redis modules require executable permissions, otherwise redis-server
+	# will refuse to start. (#989385)
+	find debian/ -name redisearch.so -print0 | xargs -0r chmod +x
+
 override_dh_compress:
 	dh_compress -X.md

=== debian/tests/control ===
Tests: load-module
Depends:
 redis-server,
 @,
Restrictions: needs-root

=== debian/watch ===
version=4
opts="uversionmangle=s/^v//g;s/-(beta|preview|rc)/~$1/g" \
https://github.com/GoodForm/RediSearch/releases .*/archive/(.*).tar.gz
